import { HttpStatus } from "@nestjs/common";
import { AuthService } from "./auth.service";
import { JwtService } from "@nestjs/jwt";
import { UsersService } from "./users/users.service";
import { WusergrpService } from "./wusergrp/wusergrp.service";
export declare class AuthController {
    private authService;
    private jwtService;
    private readonly userService;
    private readonly userGroupService;
    constructor(authService: AuthService, jwtService: JwtService, userService: UsersService, userGroupService: WusergrpService);
    login(req: any): Promise<{
        user: any;
        statusCode: HttpStatus;
        message: string;
        success: boolean;
        access_token: string;
    } | {
        user: any;
        statusCode: HttpStatus;
        success: boolean;
        message: string;
        access_token?: undefined;
    }>;
    getProfile(req: any): Promise<{
        statusCode: HttpStatus;
        success: boolean;
        message: string;
        result: any;
    } | {
        statusCode: HttpStatus;
        success: boolean;
        message: string;
        result?: undefined;
    }>;
}
