"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AuthModule = void 0;
const common_1 = require("@nestjs/common");
const jwt_1 = require("@nestjs/jwt");
const auth_service_1 = require("./auth.service");
const passport_1 = require("@nestjs/passport");
const jwt_strategy_1 = require("./jwt.strategy");
const wusergrp_module_1 = require("./wusergrp/wusergrp.module");
const roles_module_1 = require("./roles/roles.module");
const auth_controller_1 = require("./auth.controller");
const local_strategy_1 = require("./local.strategy");
const users_module_1 = require("./users/users.module");
const user_roles_module_1 = require("./user-roles/user-roles.module");
const users_service_1 = require("./users/users.service");
const roles_service_1 = require("./roles/roles.service");
const user_roles_service_1 = require("./user-roles/user-roles.service");
const users_providers_1 = require("./users/users.providers");
const dotenv = __importStar(require("dotenv"));
const utility_service_1 = require("../common/service/utility.service");
dotenv.config();
let AuthModule = class AuthModule {
};
AuthModule = __decorate([
    (0, common_1.Module)({
        imports: [
            jwt_1.JwtModule.register({
                secret: process.env.JWT_SECRET,
            }),
            passport_1.PassportModule,
            users_module_1.UsersModule,
            wusergrp_module_1.WusergrpModule,
            user_roles_module_1.UserRolesModule,
            roles_module_1.RolesModule,
        ],
        providers: [
            ...users_providers_1.usersProviders,
            auth_service_1.AuthService,
            user_roles_service_1.UserRolesService,
            users_service_1.UsersService,
            roles_service_1.RolesService,
            local_strategy_1.LocalStrategy,
            jwt_strategy_1.JwtStrategy,
            utility_service_1.UtilityService,
        ],
        exports: [
            auth_service_1.AuthService,
            jwt_1.JwtModule,
            wusergrp_module_1.WusergrpModule,
            users_service_1.UsersService
        ],
        controllers: [auth_controller_1.AuthController],
    })
], AuthModule);
exports.AuthModule = AuthModule;
