"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AuthService = void 0;
const common_1 = require("@nestjs/common");
const jwt_1 = require("@nestjs/jwt");
const users_service_1 = require("./users/users.service");
const wusergrp_service_1 = require("./wusergrp/wusergrp.service");
let AuthService = class AuthService {
    constructor(jwtService, userService, userGroupService) {
        this.jwtService = jwtService;
        this.userService = userService;
        this.userGroupService = userGroupService;
    }
    validateUser(username, pass) {
        return __awaiter(this, void 0, void 0, function* () {
            const user = yield this.userService.findByUsername(username);
            console.log(user);
            if (user && user.success && user.result.password === pass) {
                const plainUser = user.result.get({ plain: true });
                delete plainUser.password;
                let user_group = plainUser.user_group ? yield this.userGroupService.findOne(plainUser.user_group) : null;
                return Object.assign(Object.assign({}, plainUser), { user_group });
            }
            else
                return { message: "Failed" };
        });
    }
    findUser(username) {
        return __awaiter(this, void 0, void 0, function* () {
            const user = yield this.userService.findByUsername(username);
            if (user && user.success) {
                const plainUser = user.result.get({ plain: true });
                delete plainUser.password;
                return plainUser;
            }
        });
    }
    tokenDecode(token) {
        return __awaiter(this, void 0, void 0, function* () {
            const authHeaders = token;
            if (authHeaders && authHeaders.split(" ")[1]) {
                const token = authHeaders.split(" ")[1];
                const decoded = this.jwtService.decode(token);
                const user = yield this.userService.findByUsername(decoded.UserName);
                const plainUser = user.result.get({ plain: true });
                delete plainUser.password;
                return plainUser;
            }
        });
    }
    login(user) {
        return __awaiter(this, void 0, void 0, function* () {
            if (user && !user.message) {
                const payload = { UserName: user.email, ID: user.id };
                return {
                    statusCode: common_1.HttpStatus.OK,
                    message: "success",
                    success: true,
                    access_token: this.jwtService.sign(payload),
                };
            }
            else
                return {
                    statusCode: common_1.HttpStatus.BAD_REQUEST,
                    success: false,
                    message: "Invalid Username or Password",
                };
        });
    }
};
AuthService = __decorate([
    (0, common_1.Injectable)(),
    __metadata("design:paramtypes", [jwt_1.JwtService,
        users_service_1.UsersService,
        wusergrp_service_1.WusergrpService])
], AuthService);
exports.AuthService = AuthService;
