"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UsersModule = void 0;
const common_1 = require("@nestjs/common");
const users_service_1 = require("./users.service");
const users_controller_1 = require("./users.controller");
const users_providers_1 = require("./users.providers");
const auth_service_1 = require("../auth.service");
const jwt_strategy_1 = require("../jwt.strategy");
const user_roles_service_1 = require("../user-roles/user-roles.service");
const jwt_1 = require("@nestjs/jwt");
const common_2 = require("../../common");
const wusergrp_module_1 = require("../wusergrp/wusergrp.module");
let UsersModule = class UsersModule {
};
UsersModule = __decorate([
    (0, common_1.Module)({
        imports: [
            jwt_1.JwtModule.register({
                secret: process.env.JWT_SECRET,
            }),
            wusergrp_module_1.WusergrpModule
        ],
        controllers: [users_controller_1.UsersController],
        providers: [
            ...users_providers_1.usersProviders,
            users_service_1.UsersService,
            auth_service_1.AuthService,
            jwt_strategy_1.JwtStrategy,
            user_roles_service_1.UserRolesService,
            common_2.UtilityService
        ],
        exports: [users_service_1.UsersService],
    })
], UsersModule);
exports.UsersModule = UsersModule;
