"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CoreMenuRolesService = void 0;
const common_1 = require("@nestjs/common");
const core_menu_role_entity_1 = require("./entities/core-menu-role.entity");
const constants_1 = require("../../common/constants");
const common_2 = require("../../common");
let CoreMenuRolesService = class CoreMenuRolesService extends common_2.BaseService {
    constructor(model, coreMenuRoles, coreMenus, moment_service) {
        super(model);
        this.model = model;
        this.coreMenuRoles = coreMenuRoles;
        this.coreMenus = coreMenus;
        this.moment_service = moment_service;
    }
    createMenus(params, user) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                return yield this.menuCreation(Object.assign(Object.assign({}, params), { user_id: user.ID }));
            }
            catch (error) {
                return "Menu creating failed, " + error;
            }
        });
    }
    menuCreation(params) {
        return __awaiter(this, void 0, void 0, function* () {
            return yield this.coreMenus
                .findOne({
                where: {
                    id: params.menu_id,
                },
            })
                .then((result) => __awaiter(this, void 0, void 0, function* () {
                const menu_roles = yield this.coreMenuRoles.findOne({
                    where: {
                        menu_id: params.menu_id,
                        role_id: params.role_id,
                    },
                });
                if (!menu_roles) {
                    const current_date = this.moment_service.getDate(new Date(), "YYYY-MM-DD HH:mm:ss");
                    yield this.coreMenuRoles.create(Object.assign(Object.assign({}, params), { created_by: params.user_id, updated_by: params.user_id, created_at: current_date.today, updated_at: current_date.today }));
                }
                if (result.header_id) {
                    console.log("header", result.header_id);
                    yield this.menuCreation({
                        menu_id: result.header_id,
                        role_id: params.role_id,
                        user_id: params.user_id,
                    });
                }
                return "Success";
            }))
                .catch((error) => {
                return error;
            });
        });
    }
};
CoreMenuRolesService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, common_1.Inject)(constants_1.CORE_MENU_ROLES)),
    __param(1, (0, common_1.Inject)(constants_1.CORE_MENU_ROLES)),
    __param(2, (0, common_1.Inject)(constants_1.CORE_MENUS)),
    __metadata("design:paramtypes", [core_menu_role_entity_1.CoreMenuRole, Object, Object, common_2.MomentUtilities])
], CoreMenuRolesService);
exports.CoreMenuRolesService = CoreMenuRolesService;
