"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CoreMenusModule = void 0;
const common_1 = require("@nestjs/common");
const core_menus_service_1 = require("./core-menus.service");
const core_menus_controller_1 = require("./core-menus.controller");
const core_menus_providers_1 = require("./core-menus.providers");
const core_menu_role_providers_1 = require("../core-menu-roles/core-menu-role.providers");
const core_page_definitions_providers_1 = require("../core-page-definitions/core-page-definitions.providers");
const core_model_details_providers_1 = require("../core-model-details/core-model-details.providers");
const utility_service_1 = require("../../common/service/utility.service");
const user_roles_providers_1 = require("../../auth/user-roles/user-roles.providers");
const auth_service_1 = require("../../auth/auth.service");
const users_service_1 = require("../../auth/users/users.service");
const user_roles_service_1 = require("../../auth/user-roles/user-roles.service");
const jwt_strategy_1 = require("../../auth/jwt.strategy");
const jwt_1 = require("@nestjs/jwt");
const auth_1 = require("../../auth");
let CoreMenusModule = class CoreMenusModule {
};
CoreMenusModule = __decorate([
    (0, common_1.Module)({
        imports: [
            auth_1.AuthModule,
            jwt_1.JwtModule.register({
                secret: process.env.JWT_SECRET,
            }),
        ],
        controllers: [core_menus_controller_1.CoreMenusController],
        providers: [
            ...core_menus_providers_1.coreMenuProviders,
            ...core_menu_role_providers_1.coreMenuRolesProviders,
            ...core_page_definitions_providers_1.corePageDefinitionsProviders,
            ...core_model_details_providers_1.coreModelDetailsProviders,
            ...user_roles_providers_1.coreUserRolesProviders,
            core_menus_service_1.CoreMenusService,
            utility_service_1.UtilityService,
            auth_service_1.AuthService,
            jwt_strategy_1.JwtStrategy,
            users_service_1.UsersService,
            user_roles_service_1.UserRolesService,
        ],
        exports: [core_menus_service_1.CoreMenusService],
    })
], CoreMenusModule);
exports.CoreMenusModule = CoreMenusModule;
