"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DashboardController = void 0;
const common_1 = require("@nestjs/common");
const auth_1 = require("../../auth/");
const common_2 = require("../../common");
const dashboard_service_1 = require("./dashboard.service");
let DashboardController = class DashboardController extends common_2.BaseController {
    constructor(dashboardService, s) {
        super(s);
        this.dashboardService = dashboardService;
        this.s = s;
    }
    findAllMatchingDashobard(code) {
        return this.dashboardService
            .findAll(code)
            .then((result) => {
            console.log(result);
            return result;
        })
            .catch((error) => {
            console.log(error);
            throw new common_1.HttpException('No matching group found', common_1.HttpStatus.FORBIDDEN);
        });
    }
    exec(id) {
        return this.dashboardService
            .exec(id)
            .then((result) => __awaiter(this, void 0, void 0, function* () {
            if (result) {
                return {
                    statusCode: common_1.HttpStatus.OK,
                    message: "success",
                    success: true,
                    result,
                };
            }
            else {
                return {
                    statusCode: common_1.HttpStatus.OK,
                    message: "No Data Found",
                    success: false,
                    result,
                };
            }
        }))
            .catch((error) => {
            return {
                statusCode: common_1.HttpStatus.BAD_REQUEST,
                message: "failed",
                success: false,
                error,
            };
        });
    }
    popquery(id) {
        return this.dashboardService.popquery(id).then((result) => __awaiter(this, void 0, void 0, function* () {
            if (result) {
                return {
                    statusCode: common_1.HttpStatus.OK,
                    message: "success",
                    success: true,
                    result,
                };
            }
            else {
                return {
                    statusCode: common_1.HttpStatus.OK,
                    message: "No Data Found",
                    success: false,
                    result,
                };
            }
        }))
            .catch((error) => {
            return {
                statusCode: common_1.HttpStatus.BAD_REQUEST,
                message: "failed",
                success: false,
                error,
            };
        });
    }
};
__decorate([
    (0, common_1.UseGuards)(new auth_1.JwtAuthGuard({})),
    (0, common_1.Get)(':code'),
    __param(0, (0, common_1.Param)('code')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Object)
], DashboardController.prototype, "findAllMatchingDashobard", null);
__decorate([
    (0, common_1.Get)("exec/:id"),
    __param(0, (0, common_1.Param)("id", new common_1.ParseIntPipe({ errorHttpStatusCode: common_1.HttpStatus.NOT_ACCEPTABLE }))),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", Object)
], DashboardController.prototype, "exec", null);
__decorate([
    (0, common_1.Get)("pop/:id"),
    __param(0, (0, common_1.Param)("id", new common_1.ParseIntPipe({ errorHttpStatusCode: common_1.HttpStatus.NOT_ACCEPTABLE }))),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", Object)
], DashboardController.prototype, "popquery", null);
DashboardController = __decorate([
    (0, common_1.Controller)("dashboard"),
    __metadata("design:paramtypes", [dashboard_service_1.DashboardService,
        dashboard_service_1.DashboardService])
], DashboardController);
exports.DashboardController = DashboardController;
