"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.dbConnection = void 0;
const sequelize_typescript_1 = require("sequelize-typescript");
const role_entity_1 = require("./auth/roles/entities/role.entity");
const user_role_entity_1 = require("./auth/user-roles/entities/user-role.entity");
const user_entity_1 = require("./auth/users/entities/user.entity");
const core_column_definition_entity_1 = require("./core/core-column-definitions/entities/core-column-definition.entity");
const core_column_detail_entity_1 = require("./core/core-column-details/entities/core-column-detail.entity");
const core_menu_role_entity_1 = require("./core/core-menu-roles/entities/core-menu-role.entity");
const core_menu_entity_1 = require("./core/core-menus/entities/core-menu.entity");
const core_model_column_entity_1 = require("./core/core-model-columns/entities/core-model-column.entity");
const core_model_detail_entity_1 = require("./core/core-model-details/entities/core-model-detail.entity");
const core_page_definition_entity_1 = require("./core/core-page-definitions/entities/core-page-definition.entity");
const core_script_entity_1 = require("./core/core-scripts/entities/core-script.entity");
const dotenv = __importStar(require("dotenv"));
const dashboard_entity_1 = require("./core/dashboard/entities/dashboard.entity");
const wusergrp_entity_1 = require("./auth/wusergrp/entities/wusergrp.entity");
dotenv.config();
function dbConnection(config, models) {
    return __awaiter(this, void 0, void 0, function* () {
        const initial_models = [
            user_entity_1.User,
            role_entity_1.Role,
            user_role_entity_1.UserRole,
            core_menu_entity_1.CoreMenu,
            core_script_entity_1.CoreScript,
            core_column_definition_entity_1.CoreColumnDefinition,
            core_column_detail_entity_1.CoreColumnDetail,
            core_page_definition_entity_1.CorePageDefinition,
            core_model_column_entity_1.CoreModelColumn,
            core_model_detail_entity_1.CoreModelDetail,
            core_menu_role_entity_1.CoreMenuRole,
            core_script_entity_1.CoreScript,
            dashboard_entity_1.Dashboard,
            wusergrp_entity_1.Wusergrp
        ];
        console.log("Going to connect now again");
        const tables = initial_models.concat(models);
        try {
            if (config) {
                const sequelize = new sequelize_typescript_1.Sequelize(config);
                yield sequelize
                    .authenticate()
                    .then(() => {
                    console.log("Connection has been established successfully.");
                })
                    .catch((err) => {
                    console.error("Unable to connect to the database: ", err);
                });
                sequelize.addModels(tables);
                return sequelize;
            }
            else {
                console.error("Unable to connect to the database: config details not found.");
            }
        }
        catch (error) {
            console.error("Database connection error occurred: ", error);
        }
    });
}
exports.dbConnection = dbConnection;
